package com.flyfish.framework.query.chain;

import com.flyfish.framework.query.holder.QueryChainHolder;
import com.flyfish.framework.query.spi.adaptor.CriteriaAdaptor;

import java.util.function.BinaryOperator;
import java.util.function.Function;

/**
 * 默认的查询保持器
 *
 * @param <C> 泛型，交给适配器处理
 */
class DefaultQueryChainHolder<C> implements QueryChainHolder<C> {

    /**
     * 等待下一步消费
     * 如果不调用with，该状态将一直保持，可被其他link调用替换
     * 在调用with后，自动消费，并完成拼接
     *
     * @param operator 操作方法
     * @return 本身
     */
    @Override
    public QueryChainHolder<C> link(Function<CriteriaAdaptor<C>, BinaryOperator<C>> operator) {
        return null;
    }

    /**
     * 拼接条件
     *
     * @param criteria 条件
     */
    @Override
    public void with(Function<CriteriaAdaptor<C>, C> criteria) {

    }


    /**
     * 触发动作，得到最终的
     *
     * @return 本身
     */
    @Override
    public C get(CriteriaAdaptor<C> adaptor) {
        return null;
    }

    /**
     * 判断条件是否为空
     *
     * @return 结果
     */
    @Override
    public boolean isEmpty() {
        return false;
    }
}
