package com.flyfish.framework.query.spi;

import com.flyfish.framework.query.QueryChain;
import com.flyfish.framework.utils.Supportable;

/**
 * 查询链创建抽象泛型工厂
 * 基于spi提供实现类，最终返回真正实例化的内容
 * 根据引入的jar包自动加载，无需手动处理
 *
 * @author wangyu
 */
public interface QueryChainFactory<C extends QueryChain<C, ?>> extends Supportable<Class<?>> {

    /**
     * 生产适配器
     * 此接口为高度抽象接口，目的是兼容更多的查询链类型，便于后续扩展
     *
     * @return 生产结果
     */
    C produce();
}
