package com.flyfish.framework.mongodb.query.impl;

import com.flyfish.framework.query.QueryDefinition;
import com.flyfish.framework.query.QueryMutation;

/**
 * mongo的查询定义
 *
 * @author wangyu
 */
class MongoQueryDefinition implements QueryDefinition {

    protected final MongoQueryChainHolder holder = new MongoQueryChainHolder();

    /**
     * 构建
     *
     * @return 构建结果
     */
    @SuppressWarnings("unchecked")
    @Override
    public <T> T build() {
        return (T) holder.get();
    }

    /**
     * 修改，此修改会直接接着查询条件进行拼接
     *
     * @return 修改句柄
     */
    @Override
    public QueryMutation mutate() {
        return null;
    }

    /**
     * 会直接添加嵌套查询到当前查询末尾
     *
     * @return 修改句柄
     */
    @Override
    public QueryMutation within() {
        return null;
    }

    /**
     * 判断查询条件是否为空
     *
     * @return 结果
     */
    @Override
    public boolean isEmpty() {
        return holder.isEmpty();
    }
}
