package com.flyfish.framework.r2dbc.config;

import com.flyfish.framework.domain.base.Domain;
import com.flyfish.framework.r2dbc.operations.R2dbcReactiveEntityOperations;
import com.flyfish.framework.r2dbc.repository.factory.DefaultReactiveRepositoryFactoryBean;
import com.flyfish.framework.r2dbc.repository.impl.DefaultReactiveRepositoryImpl;
import com.flyfish.framework.repository.ReactiveEntityOperations;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mapping.callback.EntityCallback;
import org.springframework.data.r2dbc.config.EnableR2dbcAuditing;
import org.springframework.data.r2dbc.core.R2dbcEntityOperations;
import org.springframework.data.r2dbc.repository.config.EnableR2dbcRepositories;

/**
 * r2dbc数据配置
 *
 * @author wangyu
 */
@EnableR2dbcRepositories(
        repositoryFactoryBeanClass = DefaultReactiveRepositoryFactoryBean.class,
        repositoryBaseClass = DefaultReactiveRepositoryImpl.class
)
@EnableR2dbcAuditing
@Configuration
public class R2dbcDataConfig {

    @Bean
    public EntityCallback<Domain> r2dbcReferenceEntityCallback() {
        return new R2dbcReferenceEntityCallback();
    }

    @Bean
    @ConditionalOnBean(R2dbcEntityOperations.class)
    public ReactiveEntityOperations r2dbcReactiveEntityOperations(R2dbcEntityOperations r2dbcEntityOperations) {
        return new R2dbcReactiveEntityOperations(r2dbcEntityOperations);
    }
}
