package com.flyfish.framework.r2dbc.query.impl;

import com.flyfish.framework.query.QueryDefinition;
import com.flyfish.framework.query.QueryMutation;
import org.springframework.data.relational.core.query.Criteria;
import org.springframework.data.util.CastUtils;

/**
 * mongo的查询定义
 *
 * @author wangyu
 */
public class R2dbcQueryDefinition implements QueryDefinition {

    private Criteria criteria;

    /**
     * 构建
     *
     * @return 构建结果
     */
    @Override
    public <T> T build() {
        return CastUtils.cast(criteria);
    }

    /**
     * 修改，此修改会直接接着查询条件进行拼接
     *
     * @return 修改句柄
     */
    @Override
    public QueryMutation mutate() {
        return null;
    }

    /**
     * 会直接添加嵌套查询到当前查询末尾
     *
     * @return 修改句柄
     */
    @Override
    public QueryMutation within() {
        return null;
    }

    /**
     * 判断查询条件是否为空
     *
     * @return 结果
     */
    @Override
    public boolean isEmpty() {
        return false;
    }
}
